﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Canvasform : Form
    {     
        Color red = Color.Red;
        private Image img;
        private Graphics bmap;
        Pen white = new Pen(Color.White, 4);
        Pen white2 = new Pen(Color.White, 2);
        int[,] ArrayLayout = new int[562,1002]; //main array with every camera on it
        int[,] CopyArray = new int[562, 1002]; //main array with just the enclosure and no manipulation
        int[,] CopyArray1 = new int[562, 1002];//arrray for the first camera    
        int[,] CopyArray2 = new int[562, 1002];//array for the second camera
        List<Point> p1List = new List<Point>(); //dynamic lists for points
        List<Point> p2List = new List<Point>(); //obstacle points
        List<Point> p3List = new List<Point>(); //wall points in a row
        List<Point> p4List = new List<Point>();
        List<Point> p5List = new List<Point>();//default draw points
        int arrayX1 = 0; //contains the largest X value
        int arrayY1 = 0; //Largest Y value
        int arrayX2 = 720; //Smallest X
        int arrayY2 = 720; //Smallest Y
        Point LocationXY; //starting point
        Point LocationXY2; //Ending point
        List<int> camListX = new List<int>();//holds the cameras x coordinates  
        List<int> camListY = new List<int>();//holds the camera y coordinates
        int count;
        bool isDragging = false; //true when dragging a camera
        bool camClick = false; //true when wanting to place a camera
        bool move = false; //true when wanting to move a camera
        bool first = true; //used for manual drawing
        bool first2 = true;//used for manual drawing
        bool mouseClick = false;
        bool mouseClick2 = false;//true when mouse is clicked
        bool draw = false;//true when wanting to manually draw
        bool obstacles = false; //true when wanting to draw obstacles
        bool Def = false; // true when default enclosure drawing
        bool amt = false; //true when wanting to check what a single camera can see
        bool determined = false; //true if the original array has been copied into CopyArray
        bool first3 = false; //true if camera 1's array has been filled
        int zeros = 0; //used for percentage count
        int threes = 0;
        public Canvasform()
        {
            InitializeComponent();
            img = new Bitmap(canvas.Width, canvas.Height);
            bmap = Graphics.FromImage(img);
        }
        //When the mouse is clicked on the canvas this checks to see what button has been pressed
        //(what bool is true) and acts accordingly
        private void canvas_MouseClick(object sender, MouseEventArgs e)
        {
            //MessageBox.Show(e.X.ToString() + " " + e.Y.ToString());
            if(amt)
            {
                Amount(e);
            }

            if (draw)
            {
                if (first)
                {
                    if (mouseClick == true)
                    {
                        LocationXY2 = e.Location;   
                        p3List.Add(LocationXY2);
                        first = false;
                        Refresh(); //calls paint
                    }
                    else
                    {
                        mouseClick = true;
                        LocationXY = e.Location;
                        p1List.Add(LocationXY);
                        p3List.Add(LocationXY);
                    }
                }
                else
                {
                    p1List.Add(LocationXY);
                    p3List.Add(e.Location);
                    Refresh();
                }

            }

            if (obstacles)
            {
                if (first2)
                {
                    if (mouseClick2 == true)
                    {
                        LocationXY2 = e.Location;
                        p4List.Add(LocationXY2);
                        first2 = false;
                        Refresh(); //calls paint
                    }
                    else
                    {
                        mouseClick2 = true;
                        LocationXY = e.Location;
                        p2List.Add(LocationXY);
                        p4List.Add(LocationXY);
                    }
                }
                else
                {
                    p2List.Add(LocationXY);
                    p4List.Add(e.Location);
                   Refresh();
                }

            }

            if(camClick)
            {
                int x = e.Location.X; int y = e.Location.Y;
                
                Point pt = new Point(x, y);
                if (IsPointInPolygon4(p3List, pt) || IsPointInPolygon4(p5List, pt))
                {
                    camListX.Add(e.Location.X);
                    camListY.Add(e.Location.Y);
                    Refresh();
                }
               
            }

        }
        //Paints everything onto the canvas when Refresh() is called.
        private void canvas_Paint(object sender, PaintEventArgs e)
        {
            
            Graphics Obj = canvas.CreateGraphics();
            Pen yellow = new Pen(Color.Yellow, 2);
            Brush blue = new SolidBrush(Color.Aqua);
            Pen orange = new Pen(Color.Orange, 2);
            Obj.DrawImage(img,0,0);
            
            if (draw)
            {
                for (int x = 0; x < p1List.Count; x++)
                {  
                    bmap.DrawLine(white, p3List[x], p3List[x + 1]);
                    Obj.DrawImage(img, 0, 0);       
                }
             
            }

            if(obstacles)
            {
               
                for (int x = 0; x < p2List.Count; x++)
                {
                    bmap.DrawLine(white2, p4List[x], p4List[x + 1]);
                   
                    Obj.DrawImage(img, 0, 0);

                }
                if(camListX.Count > 0)
                DetermineArray();
            }
          

            if (camClick)
            {
                            
                for (int x = 0; x < camListX.Count; x++)
                {
                    Point pt = new Point(camListX[x], camListY[x]);
                    if (p5List.Count < 1)
                    {
                        if (IsPointInPolygon4(p3List, pt))
                            Obj.FillRectangle(blue, camListX[x], camListY[x], 5, 5);
                       
                    }
                    else
                    {
                        if (IsPointInPolygon4(p5List, pt))
                            Obj.FillRectangle(blue, camListX[x], camListY[x], 5, 5);
                       
                    }
                }
                DetermineArray();
                
            }

            if (move)
            {
                
                    
               

                for (int x = 0; x < camListX.Count; x++)
                {
                    Obj.FillRectangle(blue, camListX[x], camListY[x], 5, 5);
                }
                for (int x = 0; x < camListX.Count; x++)
                {
                    Point pt = new Point(camListX[x], camListY[x]);
                 
                }
                DetermineArray();
            }


        }

   
        //Manual drawing button is clicked
        private void btnDraw_Click(object sender, EventArgs e)
        {
            amt = false;
            if (obstacles)
                obstacles = false;
            if (Def)
                btnClear_Click(sender,e);

            if (!draw)
                draw = true;
            else   
                draw = false;
            
        }
        //draw obstacles button is clicked
        private void btnOb_Click(object sender, EventArgs e)
        {
            amt = false;
            camClick = false;
            if (draw)
                draw = false;

            if (!obstacles)
                obstacles = true;
            else             
                obstacles = false;
        }
        //clear button is clicked
        //resets everything
        private void btnClear_Click(object sender, EventArgs e)
        {
            zeros = 0;
            threes = 0;
            first3 = false;
            determined = false;
            amt = false;
            first = true;
           first2 = true;
           mouseClick = false;
           mouseClick2 = false;
            Def = false;
            camClick = false;
            move = false;
            obstacles = false;
            bmap.Clear(Color.Black);
            p1List.Clear();
            p2List.Clear();
            p3List.Clear();
            p4List.Clear();
            p5List.Clear();
            camListX.Clear();
            camListY.Clear();

            Refresh();
        }
        //default draw button is clicked 
        //Draws the default enclosure onto the bitmap
        private void btnDefault_Click(object sender, EventArgs e)
        {
            Point def1 = new Point(275, 100);
            Point def2 = new Point(375, 100);
            Point def3 = new Point(375, 200);
            Point def4 = new Point(450, 200);
            Point def5 = new Point(450, 250);
            Point def6 = new Point(275, 250);
            Point def7 = new Point(275, 100);
            p5List.Add(def1);
            p5List.Add(def2);
            p5List.Add(def3);
            p5List.Add(def4);
            p5List.Add(def5);
            p5List.Add(def6);
            p5List.Add(def7);
            
            for (int x = 0; x < p5List.Count - 1; x++)
            {
                bmap.DrawLine(white, p5List[x], p5List[x + 1]);
            }
            if (Def)
                Def = false;
            else
            {
                Def = true;
                Refresh();
            }
        }
        //camera button is clicked
        //gets the x and y extremes of the enclosure
        private void btnCamera_Click(object sender, EventArgs e)
        {
            if(p5List.Count < 1)
            {
                for (int i = 0; i < p3List.Count; i++)
                {
                    if (p3List[i].X > arrayX1)
                        arrayX1 = p3List[i].X;
                    if (p3List[i].X < arrayX2)
                        arrayX2 = p3List[i].X;
                    if (p3List[i].Y > arrayY1)
                        arrayY1 = p3List[i].Y;
                    if (p3List[i].Y < arrayY2)
                        arrayY2 = p3List[i].Y;

                }
            }
            else
            {
                for (int i = 0; i < p5List.Count; i++)
                {
                    if (p5List[i].X > arrayX1)
                        arrayX1 = p5List[i].X;
                    if (p5List[i].X < arrayX2)
                        arrayX2 = p5List[i].X;
                    if (p5List[i].Y > arrayY1)
                        arrayY1 = p5List[i].Y;
                    if (p5List[i].Y < arrayY2)
                        arrayY2 = p5List[i].Y;
                }
            }
            amt = false;
            Def = false;
            draw = false;
            obstacles = false;
            move = false;
            if (camClick)
                camClick = false;
            else
                camClick = true;

        }
        //checks if the mouse is clicked on top of a camera
        private void canvas_MouseDown(object sender, MouseEventArgs e)
        {
            Point loc = e.Location;
           
            if (move)
            {
              
                for (int i = 0; i<camListX.Count; i++)
                {

                    if ((loc.X >= (camListX[i] - 5) && loc.X <= (camListX[i] + 5)) && (loc.Y >= (camListY[i] - 5) && loc.Y <= (camListY[i] +5)))
                    {
                        count = i;
                        isDragging = true;
                        break;
                    }
                }
            }
        }
        //check cam button is clicked 
        private void btnAmt_Click(object sender, EventArgs e)
        {
            obstacles = false;
            Def = false;
            camClick = false;
            draw = false;
            obstacles = false;
            move = false;

            if (amt)
                amt = false;
            else
                amt = true;
        }
        //move cameras button is clicked
        private void btnMove_Click(object sender, EventArgs e)
        {
            amt = false;
            obstacles = false;
            Def = false;
            camClick = false;
           draw = false;

            if (move)
                move = false; 
            else
                move = true;
        }
        //if the mouse is down on a camera and moving it updates the location of the camera and redraws it
        private void canvas_MouseMove(object sender, MouseEventArgs e)
        {
            if(isDragging)
            {               
                    camListX[count] = e.Location.X;
                    camListY[count] = e.Location.Y;
                    Refresh();
            
            }
        }
        //mouse click is let up stopping the cameras movement
        private void canvas_MouseUp(object sender, MouseEventArgs e)
        {
            if (isDragging)
            {
                isDragging = false;
                Refresh();
            }
        
        }

        /// <summary>
        /// Determines if the given point is inside the polygon
        /// </summary>
        /// <param name="polygon">the vertices of polygon</param>
        /// <param name="testPoint">the given point</param>
        /// <returns>true if the point is inside the polygon; otherwise, false</returns>
        /// https://stackoverflow.com/questions/4243042/c-sharp-point-in-polygon
        public static bool IsPointInPolygon4(List<Point> polygon, Point testPoint)
        {
            bool result = false;
            int j = polygon.Count() - 1;
            for (int i = 0; i < polygon.Count(); i++)
            {
                if (polygon[i].Y < testPoint.Y && polygon[j].Y >= testPoint.Y || polygon[j].Y < testPoint.Y && polygon[i].Y >= testPoint.Y)
                {
                    if (polygon[i].X + (testPoint.Y - polygon[i].Y) / (polygon[j].Y - polygon[i].Y) * (polygon[j].X - polygon[i].X) < testPoint.X)
                    {
                        result = !result;
                    }
                }
                j = i;
            }
            return result;
        }
        //Populates the arrays from a bitmap
        //spot gets a 1 if its a wall or obstacle, 2 if its camera, 0 if its empty space in the enclosure.
        //copies the screen to a bitmap and then uses the pixels info 
        public void DetermineArray()
        {
            Bitmap destBitmap = new Bitmap(canvas.Width, canvas.Height);
            Rectangle bounds = this.Bounds;
            Graphics gr = Graphics.FromImage(destBitmap);
            gr.CopyFromScreen(bounds.Left + 8,bounds.Top+31, 0, 0, canvas.Size);
            Graphics Obj = canvas.CreateGraphics();
            if (p3List.Count < 1)
            {
                for (int i = 0; i < canvas.Width; i++)
                {
                    for (int j = 0; j < canvas.Height; j++)
                    {


                        if (destBitmap.GetPixel(i, j) == Color.FromArgb(255, 255, 255))
                        {
                            ArrayLayout[j, i] = 1;

                        }
                        else if (IsPointInPolygon4(p5List, new Point(i, j)) && destBitmap.GetPixel(i, j) != Color.FromArgb(0, 0, 0))
                        {
                            ArrayLayout[j, i] = 2;
                        }
                        else if (IsPointInPolygon4(p5List, new Point(i, j)))
                        {
                            ArrayLayout[j, i] = 0;
                        }
                        else
                        {
                            ArrayLayout[j, i] = 5;
                        }


                    }
                }
            }
            else
            {
                for (int i = 0; i < canvas.Width; i++)
                {
                    for (int j = 0; j < canvas.Height; j++)
                    {


                        if (destBitmap.GetPixel(i, j) == Color.FromArgb(255, 255, 255))
                        {
                            ArrayLayout[j, i] = 1;

                        }
                        else if (IsPointInPolygon4(p3List, new Point(i, j)) && destBitmap.GetPixel(i, j) != Color.FromArgb(0, 0, 0))
                        {
                            ArrayLayout[j, i] = 2;
                        }
                        else if (IsPointInPolygon4(p3List, new Point(i, j)))
                        {
                            ArrayLayout[j, i] = 0;
                        }
                        else
                        {
                            ArrayLayout[j, i] = 5;
                        }


                    }
                }
            }

            if(determined == false)
            {
                determined = true;                  
                CopyArray = (int[,]) ArrayLayout.Clone();
                for (int i = 50; i < 550; i++)
                {
                    for (int j = 50; j <= 500; j++)
                    {

                        if (CopyArray[i, j] == 0)
                            zeros = zeros + 1;
                    }

                }
              
            }

            for (int i = 0; i < camListX.Count; i++) {
                for (int k = arrayX2; k <= arrayX1; k++)
                {
                    for (int j = arrayY2; j <= arrayY1; j++)
                    {
                        if (k == arrayX2 || k == arrayX1 || j == arrayY2 || j == arrayY1)
                        {
                            supercover_line(ArrayLayout, new Point(camListX[i], camListY[i]), new Point(k, j));
                        }
                          
                    }
                   
                }
                if (!first3)
                {
                    CopyArray1 = (int[,]) ArrayLayout.Clone();
                    first3 = true;
                }
                else
                {
                    int[,] CopyArray3 = (int[,]) CopyArray.Clone();
                    for (int k = arrayX2; k <= arrayX1; k++)
                    {
                        for (int j = arrayY2; j <= arrayY1; j++)
                        {
                            if (k == arrayX2 || k == arrayX1 || j == arrayY2 || j == arrayY1)
                            {
                                supercover_line(CopyArray3, new Point(camListX[i], camListY[i]), new Point(k, j));
                            }

                        }

                    }
                    CopyArray2 = (int[,]) CopyArray3.Clone();
                }
            }

            for (int i = 0; i < canvas.Width; i++)
            {
                for (int j = 0; j < canvas.Height; j++)
                {
                    if(ArrayLayout[j,i] == 3)
                    {
                        destBitmap.SetPixel(i, j, red);
                        
                    }
                }
            }
            threes = 0;
            for (int i = 50; i < 550; i++)
            {
                for (int j = 50; j <= 500; j++)
                {

                    if (ArrayLayout[i, j] == 3)
                        threes = threes + 1;
                }

            }
            lblPer.Text = Math.Round((double)(100 * threes) / zeros).ToString() + "%";
            Obj.DrawImage(destBitmap, 0, 0);
           
            
                //for (int i = 0; i < ArrayLayout.GetLength(0); i++)
                //{
                //    for (int j = 0; j < ArrayLayout.GetLength(1); j++)
                //    {

                //        Console.Write(string.Format("{0} ", CopyArray[i, j]));
                //    }
                //    Console.Write(Environment.NewLine + Environment.NewLine);
                //}
            
        }

        //adapted from https://www.redblobgames.com/grids/line-drawing.html 
        //with the help of Dr.McVey
        //determines what can be seen between two points and updates the array
        public void supercover_line(int [,] M, Point p0, Point p1)
        {      
            int dx = p1.X - p0.X, dy = p1.Y - p0.Y;
            int nx = Math.Abs(dx), ny = Math.Abs(dy);
            int sign_x = dx > 0 ? 1 : -1, sign_y = dy > 0 ? 1 : -1;

            Point p = p0;
            //var points = [new Point(p.x, p.y)];
            for (int ix = 0, iy = 0; ix < nx || iy < ny;)
            {
                if ((0.5 + ix) / nx == (0.5 + iy) / ny)
                {
                    // next step is diagonal
                    
                    p.X += sign_x;
                    p.Y += sign_y;
                    ix++;
                    iy++;
                }
                else if ((0.5 + ix) / nx < (0.5 + iy) / ny)
                {
                    // next step is horizontal
                    p.X += sign_x;
                    ix++; 
                }
                else
                {
                    // next step is vertical
                    p.Y += sign_y; 
                    iy++;
                }
                //points.push(new Point(p.x, p.y));
                //M[p.x][p.y] = 5; change them down here
                if (M[p.Y, p.X] == 1)
                {
                   
                    break;
                }
                else
                {                   
                     if (M[p.Y, p.X] != 2)
                    M[p.Y, p.X] = 3;
                }

            }
           
        }
        //determines the percentage of what each camera can see
        //redraws the screen with what each camera can see
       public void Amount(MouseEventArgs e)
        {
            Bitmap destBitmap = new Bitmap(canvas.Width, canvas.Height);
            Rectangle bounds = this.Bounds;
            Graphics gr = Graphics.FromImage(destBitmap);
            gr.CopyFromScreen(bounds.Left + 8, bounds.Top + 31, 0, 0, canvas.Size);
            Graphics Obj = canvas.CreateGraphics();

            Point loc = e.Location;

             
            for (int i = 0; i < camListX.Count; i++)
                {
                
                if ((loc.X >= (camListX[i] - 5) && loc.X <= (camListX[i] + 5)) && (loc.Y >= (camListY[i] - 5) && loc.Y <= (camListY[i] + 5)))
                    {
                   
                    if (i == 0)
                    {
                        threes = 0;
                        for (int k = 50; k < 550; k++)
                        {
                            for (int j = 50; j <= 500; j++)
                            {

                                if (CopyArray1[k, j] == 3)
                                    threes = threes + 1;
                            }
                        }
                        for (int k = 0; k < canvas.Width; k++)
                        {
                            for (int j = 0; j < canvas.Height; j++)
                            {
                                if (CopyArray1[j, k] == 3)
                                {
                                    destBitmap.SetPixel(k, j, red);

                                }
                                else if(CopyArray1[j, k] == 0)
                                {
                                    destBitmap.SetPixel(k, j, Color.Black);

                                }
                            }
                        }
                    }

                    else if(i == 1)
                    {
                        threes = 0;
                        for (int k = 50; k < 550; k++)
                        {
                            for (int j = 50; j <= 500; j++)
                            {

                                if (CopyArray2[k, j] == 3)
                                    threes = threes + 1;
                            }

                        }
                        for (int k = 0; k < canvas.Width; k++)
                        {
                            for (int j = 0; j < canvas.Height; j++)
                            {
                                if (CopyArray2[j, k] == 3)
                                {
                                    destBitmap.SetPixel(k, j, red);

                                }
                                else if (CopyArray2[j, k] == 0)
                                {
                                    destBitmap.SetPixel(k, j, Color.Black);

                                }
                                
                            }
                        }
                    }

                    }
                }




            lblPer.Text = Math.Round((double)(100 * threes) / zeros).ToString() + "%";
            Obj.DrawImage(destBitmap, 0, 0);
        }
    }
}
